Description
Hello,

Aesara seems like a free alternative for multi-dimensional array manipulation and differentiation a.k.a. tensor manipulation (which
can be used for deep learning). It is based on Theano and PyMC.

https://aesara.readthedocs.io/en/latest/introduction.html

e These are dependencies available on AUR (unpackaged software):
o https://aur.archlinux.org/packages/python-etuples
o https://aur.archlinux.org/packages/python-multipledispatch
o https://aur.archlinux.org/packages/python-cons
= https://aur.archlinux.org/packages/python-logical-unification

Related issues:

Related to Packages - Freedom Issue #3110: [python-pytorch] requires intel-mk... fixed
Related to Packages - Freedom Issue #3326: [python-pytorch-opt-cuda] Depends ... fixed
Related to Packages - Packaging Request #2599: [tensorflow] depends on non-fr... open
History

#1 - 2023-03-31 12:00 PM - bill-auger

- Priority changed from bug to wish

an alternative to what though? - is there a blacklisted package that this could replace?

#2 - 2023-03-31 10:04 PM - nona

| didn't want to mention PyTorch, TensorFlow, CNTK and all its derivatives. PyTorch is still in the repos, but some time ago it was added to the very
long list of software which needs to be kicked out, a.k.a. blacklisted (or preemptively checked). In that particular case, it cannot be compiled without
intel-mkl. Scikit-Learn is not an alternative for the type of gradient optimisation which is needed for CNN or deep learning (quote needed, but | read it
on their own website--it has to do with GPU).

Translation: PyTorch is not yet black-listed. It is in the list to be checked. It can only be compiled with intel-mkl.

Aesara seems to be a successor of Theano (development stopped circa 2018). PyMC will fork Aesara into PyTensor and we may end with an
alternative.

Cheers, bill. Nice to read you again.

#3 - 2023-03-31 11:25 PM - bill-auger
- Related to Freedom Issue #3110: [python-pytorch] requires intel-mkl (unfree) added

#4 - 2023-03-31 11:25 PM - bill-auger
- Related to Freedom Issue #3326: [python-pytorch-opt-cuda] Depends on proprietary, blacklisted packages added

#5 - 2023-03-31 11:27 PM - bill-auger
- Related to Packaging Request #2599: [tensorflow] depends on non-free bazel added

#6 - 2023-04-02 01:23 PM - nona

For completeness, Aesara does not support GPU at the moment:

device (cpu)
Doc: Default device for computations. only cpu is supported for now
Value: cpu

Also: https://discourse.pymc.io/t/gpu-acceleration-with-aesara/9814, https://github.com/pymc-devs/pymc/issues/5894
